<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      style="with"
      size="small"
      :inline="true"
      v-show="showSearch"
      label-width="100px"
    >
      <el-form-item label="产品名称" prop="itemName">
        <el-input
          v-model="queryParams.itemName"
          placeholder="请输入产品名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
          >重置</el-button
        >
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['mes:pro:productionMake:edit']"
          >修改</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['mes:pro:productionMake:remove']"
          >删除</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['mes:pro:productionMake:export']"
          >导出</el-button
        >
      </el-col>
      <right-toolbar
        :showSearch.sync="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="productionMakeList"
      row-key="productionMakeId"
      default-expand-all
    >
      <el-table-column
        label="量产制作单编码"
        width="180"
        prop="productionMakeCode"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            @click="handleView(scope.row)"
            v-hasPermi="['mes:pro:productionMake:query']"
            >{{ scope.row.productionMakeCode }}</el-button
          >
        </template>
      </el-table-column>
      <el-table-column
        label="产品名称"
        width="400"
        align="center"
        prop="itemName"
        :show-overflow-tooltip="true"
      />
      <el-table-column label="工艺路线名称" width="200" align="center" prop="routeName">
      </el-table-column>
      <el-table-column label="确认人" align="center" prop="identifyingPeople">
      </el-table-column>
      <el-table-column
        label="确认日期"
        align="center"
        prop="identifyingDate"
      />
      <el-table-column
        label="印刷正面颜色"

        align="center"
        prop="printingFrontcolorName"
      />
      <el-table-column
        label="印刷背面颜色"

        align="center"
        prop="printingBackcolorName"
      />
      <el-table-column label="测试标准" align="center" prop="testStandard" />
      <el-table-column
        label="制作单状态"
        align="center"
        prop="productionMakeStatus"
      >
        <template slot-scope="scope">
          <dict-tag
            :options="dict.type.mes_productionMake_status"
            :value="scope.row.productionMakeStatus"
          />
        </template>
      </el-table-column>
      <el-table-column
        label="操作"
        width="200px"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            v-if="scope.row.productionMakeStatus == 0"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['mes:pro:productionMake:edit']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="text"
            icon="el-icon-circle-check"
            v-if="scope.row.productionMakeStatus == 0"
            @click="handleFinish(scope.row)"
            v-hasPermi="['mes:pro:productionMake:update']"
            >完成</el-button
          >
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['mes:pro:productionMake:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>
    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
  </div>
</template>

<script>
import ItemSelect from "@/components/itemSelect/single.vue";
import ClientSelect from "@/components/clientSelect/single.vue";
import VendorSelect from "@/components/vendorSelect/single.vue";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
// 新增js
import {
  listProductionMake,
  getProductionMake,
  delProductionMake,
  addProductionMake,
  dofinish,
} from "@/api/mes/pro/productionMake";
export default {
  name: "ProductionMake",
  dicts: [
    "mes_order_status",
    "mes_productionMake_sourcetype",
    "mes_productionMake_type",
    "mes_productionMake_status",
  ],
  components: {
    Treeselect,
    ItemSelect,
    ClientSelect,
    VendorSelect,
  },
  data() {
    return {
      //自动生成编码
      autoGenFlag: false,
      optType: undefined,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 显示搜索条件
      showSearch: true,
      // 非单个禁用
      single: true,
      // 总条数
      total: 0,
      // 非多个禁用
      multiple: true,
      // 生产工单表格数据
      productionMakeList: [],
      // 生产工单树选项
      productionMakeOptions: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        itemName: null, // 可以查简称与英文名
        productionMakeStatus: null,
      },
      options: [
        { value: "0", label: "待检查" },
        { value: "1", label: "待制作" },
        { value: "2", label: "制造中" },
        { value: "3", label: "待质检" },
        { value: "4", label: "待确认" },
        { value: "5", label: "已完成" },
      ],

      // 表单参数
      form: {},
      // 表单校验
      rules: {
        // productionMakeCode: [
        //   { required: true, message: "工单编码不能为空", trigger: "blur" }
        // ],
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询生产工单列表 */
    getList() {
      this.loading = true;
      listProductionMake(this.queryParams).then((response) => {
        this.productionMakeList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        screenItem: null,
        pibanItem: null,
        diecuttingItem: null,
        standardColor: null,
        module: null,
        col: null,
        row: null,
        buttstrapNum: null,
        coldoubleCutspacing: null,
        rowdoubleCutspacing: null,
        sendworkMultiple: null,
        printingPaperlenth: null,
        printPaperwidth: null,
        frontColorId: null,
        oppositeColorId: null,
        ngReason: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,

        //新增产量制作单
        productionMakeId: null,
        productionMakeCode: null,
        productionRequestId: null,
        itemId: null,
        routeId: null,
        identifyingPeople: null,
        identifyingDate: null,
        printingFrontcolor: null,
        printingBackcolor: null,
        shoeImg: null,
        prototype: null,
        productionMakeStatus: null,
        remark: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd(row) {
      // 跳转到申请单界面
      this.$router.push("/mes/pro/productionMake/apply");
      return;
    },
    // 查询明细按钮操作
    handleView(row) {
      this.reset();
      const productionMakeId = row.productionMakeId || this.ids;
      this.$router.push(
        "/mes/pro/productionMake/info?productionMakeId=" + productionMakeId
      );
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const productionMakeId = row.productionMakeId || this.ids;
      this.$router.push(
        "/mes/pro/productionMake/edit?productionMakeId=" + productionMakeId
      );
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      this.$modal
        .confirm(
          '是否确认删除编号为"' + row.productionMakeCode + '"的量产制作单？'
        )
        .then(function () {
          return delProductionMake(row.productionMakeId);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },

    handleSelectProduct() {
      this.$refs.itemSelect.showFlag = true;
    },
    handleSelectClient() {
      this.$refs.clientSelect.showFlag = true;
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "mes/pro/productionMake/export",
        {
          ...this.queryParams,
        },
        `量产申请单_${new Date().getTime()}.xlsx`
      );
    },
    // 审批
    handleFinish(row) {
      row.productionMakeStatus = 1;
      this.$modal
        .confirm("确认通过量产制作单？一旦确认，此工单将无法继续修改")
        .then(function () {
          return dofinish(row); //完成申请单审批
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("审批成功");
        })
        .catch(() => {});
    },
    handleStartMake(row) {
      row.productionMakeStatus = 2;
      this.$modal
        .confirm("确认通过量产制作单？一旦确认，此工单将无法继续修改")
        .then(function () {
          return dofinish(row); //完成申请单审批
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("审批成功");
        })
        .catch(() => {});
    },
  },
};
</script>
